/*
 * leds
 * Linux Editor for D 
 * S as in simple(superfluous) or supperb
 * 
 * by Antonio Monteiro
 */

module leds.ExecConsole;

private import dui.All;

private import leds.Workspace;
private import leds.SystemConsole;
private import leds.Docker;
private import leds.POpen;


/**
 * SystemConsole
 */
public:
class ExecConsole : SystemConsole
{
	
	char[] tabName;
	/**
	 * Creates a new System console for a workspace
	 * @param workspace
	 */
	this(Workspace workspace, char[] label)
	{
		super(workspace);
		tabName = label.dup;
	}

	Widget getWidget()
	{
		return this;
	}
	
	char[] getTabName()
	{
		return tabName;
	}

	Menu getTabMenu()
	{
		if ( tabMenu === null )
		{
			tabMenu = new Menu();
			MenuItem item;
			
			tabMenu.append(new MenuItem(this,"_Close","tabMenu.close"));
			tabMenu.append(new MenuItem(this,"_Float","tabMenu.float"));
		}
		return tabMenu;
	}

	void activateItemCallback(MenuItem menuItem, char [] action)
	{
		printf("Workspace.MenuListener.ctivateItemCallback %.*s\n",action);
	}

	/**
	 * Menu listener callback
	 */
	void activateCallback(MenuItem menuItem, char [] action)
	{
		switch(action)
		{
			case "tabMenu.close":
				if ( docker !== null )
				{
					docker.undockCurrent();
				}
				break;

			default:
				super.activateCallback(menuItem, action);
				break;
		}
	}

};